1
0
mirror of git://projects.qi-hardware.com/wernermisc.git synced 2024-11-14 09:13:44 +02:00
wernermisc/qpkg/Makefile
Werner Almesberger 9481934c9a qpkg: Makefile cleanup and added OpenWRT target
- Makefile: added automatic dependenceies (needs SHELL = /bin/bash)
- Makefile: added non-verbose builds
- Makefile (jlime): set CC_normal instead of CC, so that also cross-builds
  can be non-verbose
- Makefile (openwrt): new target to cross-compile for OpenWRT with uClibc
- Makefile (spotless): added "spotless" target
- gobble.c: uClibc may not have posix_madvise, so replace it with a dummy
  if building for uClibc
2010-11-20 07:14:52 -03:00

75 lines
1.8 KiB
Makefile

SHELL = /bin/bash
OBJS_qpkg = gobble.o id.o prereq.o qpkg.o jrb.o
OBJS_rbtest = rbtest.o jrb.o
OBJS = $(OBJS_qpkg) $(OBJS_rbtest)
CFLAGS = -Wall -Wshadow -Wmissing-prototypes -g -O
# -O, so that we get data flow analysis, which helps to find more bugs
#LDFLAGS=-pg
# ----- Verbosity control -----------------------------------------------------
CC_normal := $(CC)
DEPEND_normal := $(CPP) $(CFLAGS) -MM -MG
CC_quiet = @echo " CC " $@ && $(CC_normal)
DEPEND_quiet = @$(DEPEND_normal)
ifeq ($(V),1)
CC = $(CC_normal)
DEPEND = $(DEPEND_normal)
else
CC = $(CC_quiet)
DEPEND = $(DEPEND_quiet)
endif
# ----- Rules -----------------------------------------------------------------
.PHONY: all jlime openwrt clean spotless
all: qpkg rbtest
jlime:
$(MAKE) clean
$(MAKE) CC_normal=mipsel-linux-gcc
#
# OpenWRT uses mipsel-openwrt-linux-* and mipsel-openwrt-linux-uclibc-*.
# They should both be available, but just in case, let's improve our odds
# of picking a compiler that actualy exists.
#
openwrt:
$(MAKE) clean
$(MAKE) CC_normal=$(shell \
n=`which mipsel-openwrt-linux-gcc`; \
echo "$${n:-`which mipsel-openwrt-linux-uclibc-gcc`}")
qpkg: $(OBJS_qpkg)
rbtest: $(OBJS_rbtest)
# ----- Cleanup ---------------------------------------------------------------
clean:
rm -f $(OBJS) $(OBJS:.o=.d)
spotless: clean
rm -f qpkg rbtest
# ----- Dependencies ----------------------------------------------------------
# compile and generate dependencies, from fped, based on
# http://scottmcpeak.com/autodepend/autodepend.html
%.o: %.c
$(CC) -c $(CFLAGS) $*.c -o $*.o
$(DEPEND) $*.c | \
sed -e \
'/^\(.*:\)\? */{p;s///;s/ *\\\?$$/ /;s/ */:\n/g;H;}' \
-e '$${g;p;}' -e d >$*.d; \
[ "$${PIPESTATUS[*]}" = "0 0" ] || { rm -f $*.d; exit 1; }
-include $(OBJS:.o=.d)